<?php

namespace Modules\Lpj\Http\Controllers;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Maatwebsite\Excel\Facades\Excel;
use Modules\Lpj\Models\JenisLaporan;
use Modules\Lpj\Exports\JenisLaporanExport;
use Modules\Lpj\Http\Requests\JenisLaporanRequest;
use Throwable;

class JenisLaporanController extends Controller
{
    public $user;

    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        return view('lpj::jenis_laporan.index');
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('lpj::jenis_laporan.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(JenisLaporanRequest $request)
    {
        $validate = $request->validated();

        if ($validate) {
            try {
                JenisLaporan::create($validate);
                return redirect()
                    ->route('basicdata.jenis_laporan.index')
                    ->with('success', 'Jenis Laporan created successfully');
            } catch (Throwable $e) {
                return redirect()
                    ->route('basicdata.jenis_laporan.create')
                    ->with('success', 'Failed to create Jenis Laporan: ' . $e);
            }
        }
    }

    /**
     * Show the specified resource.
     */
    public function show($id)
    {
        // return view('lpj::show');
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($id)
    {
        $jenisLaporan = JenisLaporan::find($id);
        return view('lpj::jenis_laporan.create', compact('jenisLaporan'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(JenisLaporanRequest $request, $id)
    {
        $validate = $request->validated();

        if ($validate) {
            try {
                $jenisLaporan = JenisLaporan::find($id);
                $jenisLaporan->update($validate);
                return redirect()
                    ->route('basicdata.jenis_laporan.index')
                    ->with('success', 'Jenis Laporan updated successfully');
            } catch (Throwable $e) {
                return redirect()
                    ->route('basicdata.jenis_laporan.edit', $id)
                    ->with('success', 'Failed to update Jenis Laporan: ' . $e);
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($id)
    {
        try {
            // Delete from database
            $jenisLaporan = JenisLaporan::find($id);
            $jenisLaporan->delete();

            echo json_encode(['success' => true, 'message' => 'Jenis Laporan deleted successfully']);
        } catch (Throwable $e) {
            echo json_encode(['success' => false, 'message' => 'Failed to delete jenis Laporan']);
        }
    }

    public function dataForDatatables(Request $request)
    {
        if (is_null($this->user) || !$this->user->can('jenis_jaminan.view')) {
            //abort(403, 'Sorry! You are not allowed to view users.');
        }

        // Retrieve data from the database
        $query = JenisLaporan::query();

        // Apply search filter if provided
        if ($request->has('search') && !empty($request->get('search'))) {
            $search = $request->get('search');
            $query->where(function ($q) use ($search) {
                $q->where('code', 'LIKE', "%$search%");
                $q->orWhere('name', 'LIKE', "%$search%");
            });
        }

        // Apply sorting if provided
        if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
            $order  = $request->get('sortOrder');
            $column = $request->get('sortField');
            $query->orderBy($column, $order);
        }

        // Get the total count of records
        $totalRecords = $query->count();

        // Apply pagination if provided
        if ($request->has('page') && $request->has('size')) {
            $page   = $request->get('page');
            $size   = $request->get('size');
            $offset = ($page - 1) * $size; // Calculate the offset

            $query->skip($offset)->take($size);
        }

        // Get the filtered count of records
        $filteredRecords = $query->count();

        // Get the data for the current page
        $data = $query->get();

        // Calculate the page count
        $pageCount = ceil($totalRecords / $request->get('size'));

        // Calculate the current page number
        $currentPage = 0 + 1;

        // Return the response data as a JSON object
        return response()->json([
            'draw'            => $request->get('draw'),
            'recordsTotal'    => $totalRecords,
            'recordsFiltered' => $filteredRecords,
            'pageCount'       => $pageCount,
            'page'            => $currentPage,
            'totalCount'      => $totalRecords,
            'data'            => $data,
        ]);
    }

    public function export()
    {
        return Excel::download(new JenisLaporanExport, 'jenis_laporan.xlsx');
    }
}
